/* 			Output flags format:

                          operand
 operand   reg1   r2_base prefix
                         
                         
  Ŀ
   7  6  5  4  3  2  1  0 
  
                             
                             
      index   offset   just   memory
                      prefix  prefix
*/

#define  OUT_FLAG_OPERAND   	0x80	//10000000b
#define  OUT_FLAG_INDEX         0x40	//01000000b
#define  OUT_FLAG_REG1          0x20	//00100000b
#define  OUT_FLAG_OFFSET        0x10	//00010000b
#define  OUT_FLAG_REG2BASE      0x08	//00001000b
#define  OUT_FLAG_JUST_PREFIX   0x04	//00000100b
#define  OUT_FLAG_O_PREFIX      0x02	//00000010b
#define  OUT_FLAG_A_PREFIX      0x01	//00000001b


/*Output extended flags format:


                W-bite state
                    
                    
ex-flags:      Ŀ
                7  6  5  4  3  2  1  0 
               
                        
                        
              D state  regmem [reg=0;mem=1]
*/

#define  D_STATE                0x80	//10000000b       ;(d=1  mem->reg  /d=0  mem<-reg  )
#define  W_STATE                0x40	//01000000b       ;(0-work with bytes /1-work with dwords/words)
#define  REG_MEM                0x20	//00100000b


#define  MASK1_2                0x20	//00100000b
#define  MASK1_3                0x40	//01000000b
#define  MASK1_4                0x60    //01100000b
#define  MASK1_5                0x80    //10000000b
#define  MASK1_6                0xA0    //10100000b
#define  MASK1_7                0xC0    //11000000b
#define  FULL_MASK1             0xE0	//11100000b

#define  EX_0F                  0x10    //00010000b
#define  EXEPT_NEED             0x08	//00001000b
#define  MODR_M                 0x01    //00000001b
#define  DW_EXIST               0x02	//00000010b



//=============================================================================
//	   Operand state:
//	   ~~~~~~~~~~~~~
//         00=no operand
//         01=8 bytes
//         10=dword/word
//         11=just operand
//=============================================================================


/*

 Ŀ
 op_add  modr/m  prefix_state reg/kop 
 
      Ŀ Ŀ            
  mask_flag Ŀ           Ŀ modr_m_flag
                          
      ͳ7 6 5432107 65 432 1 0ͼ    mask1        mask2   
          Ľ                   
                        Ŀ
                    Ŀ Ŀ      
                                                
    Ŀ
    len_mask  0f cop_exept d(1)/s(0)  operand cop 
    


Prefixes:
~~~~~~~~

01b = offset prefix
00b = no prefix
10b = operand prefix
11b = just Prefix

*/

#define  ENABLE_EXEPT1          0x01	//00000001b
#define  ENABLE_EXEPT2          0x02 	//00000010b
#define  ENABLE_EXEPT3          0x04	//00000100b
#define  C_OP                   0x08	//00001000b

#define  OP_NO_OPERAND          0x00	//00000000b
#define  OP_BYTE_OPERAND        0x10	//00010000b
#define  OP_DWORD_OPERAND       0x20	//00100000b
#define  OP_JUST_OPERAND        0x30	//00110000b
#define  A_PREFIX               0x40	//01000000b
#define  O_PREFIX               0x80	//10000000b
#define  _PREFIX                0xC0    //11000000b

#define  EXEPT_OP_1             0x07	//111b
#define  EXEPT_OP_2             0x00	//000b
#define  EXEPT_OP_3             0x00    //000b



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//				DIZX32	Structures
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


struct opcode {
                 BYTE 	mask_flag;
                 BYTE 	modr_m_flag;
                 BYTE 	mask1;
                 BYTE 	mask2;
	      };


struct output {
                 BYTE	com_size;
                 BYTE 	prefix_size;

                 BYTE	o_flags;
                 BYTE   ex_flags;

		 BYTE   modrm;
		 BYTE   sib;

                 BYTE   scale;
                 BYTE   index;
                 BYTE   reg2;
                 BYTE   reg1;

                 BYTE   size_mem;
                 BYTE   size_operand;

                 DWORD  mem_offset;
                 DWORD  operand;
		 WORD   operand_add;

                 struct opcode descryptor;
	       };